/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSCanvasPixelArray.h"

#include <wtf/GetPtr.h>

#include <kjs/PropertyNameArray.h>
#include "CanvasPixelArray.h"

#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSCanvasPixelArray)

/* Hash table */

static const HashTableValue JSCanvasPixelArrayTableValues[2] =
{
    { "length", (intptr_t)JSCanvasPixelArray::LengthAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSCanvasPixelArrayTable = { 0, JSCanvasPixelArrayTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSCanvasPixelArrayPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSCanvasPixelArrayPrototypeTable = { 0, JSCanvasPixelArrayPrototypeTableValues, 0 };

const ClassInfo JSCanvasPixelArrayPrototype::s_info = { "CanvasPixelArrayPrototype", 0, &JSCanvasPixelArrayPrototypeTable, 0 };

JSObject* JSCanvasPixelArrayPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSCanvasPixelArray.prototype]]");
    return JSC::cacheGlobalObject<JSCanvasPixelArrayPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSCanvasPixelArray::s_info = { "CanvasPixelArray", 0, &JSCanvasPixelArrayTable , 0 };

JSCanvasPixelArray::JSCanvasPixelArray(JSObject* prototype, CanvasPixelArray* impl)
    : DOMObject(prototype)
    , m_impl(impl)
{
}

JSCanvasPixelArray::~JSCanvasPixelArray()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSCanvasPixelArray::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    const HashEntry* entry = JSCanvasPixelArrayTable.entry(exec, propertyName);
    if (entry) {
        slot.setStaticEntry(this, entry, staticValueGetter<JSCanvasPixelArray>);
        return true;
    }
    bool ok;
    unsigned index = propertyName.toUInt32(&ok, false);
    if (ok && index < static_cast<CanvasPixelArray*>(impl())->length()) {
        slot.setCustomIndex(this, index, indexGetter);
        return true;
    }
    return getStaticValueSlot<JSCanvasPixelArray, Base>(exec, &JSCanvasPixelArrayTable, this, propertyName, slot);
}

bool JSCanvasPixelArray::getOwnPropertySlot(ExecState* exec, unsigned propertyName, PropertySlot& slot)
{
    if (propertyName < static_cast<CanvasPixelArray*>(impl())->length()) {
        slot.setCustomIndex(this, propertyName, indexGetter);
        return true;
    }
    return getOwnPropertySlot(exec, Identifier::from(exec, propertyName), slot);
}

JSValue* JSCanvasPixelArray::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case LengthAttrNum: {
        CanvasPixelArray* imp = static_cast<CanvasPixelArray*>(impl());
        return jsNumber(exec, imp->length());
    }
    }
    return 0;
}

void JSCanvasPixelArray::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    bool ok;
    unsigned index = propertyName.toUInt32(&ok, false);
    if (ok) {
        indexSetter(exec, index, value);
        return;
    }
    Base::put(exec, propertyName, value, slot);
}

void JSCanvasPixelArray::put(ExecState* exec, unsigned propertyName, JSValue* value)
{
    indexSetter(exec, propertyName, value);
    return;
}

void JSCanvasPixelArray::getPropertyNames(ExecState* exec, PropertyNameArray& propertyNames)
{
    for (unsigned i = 0; i < static_cast<CanvasPixelArray*>(impl())->length(); ++i)
        propertyNames.add(Identifier::from(exec, i));
     Base::getPropertyNames(exec, propertyNames);
}

CanvasPixelArray* toCanvasPixelArray(JSC::JSValue* val)
{
    return val->isObject(&JSCanvasPixelArray::s_info) ? static_cast<JSCanvasPixelArray*>(val)->impl() : 0;
}

}
