/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSHTMLFieldSetElement.h"

#include <wtf/GetPtr.h>

#include "HTMLFieldSetElement.h"
#include "HTMLFormElement.h"
#include "JSHTMLFormElement.h"

#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSHTMLFieldSetElement)

/* Hash table */

static const HashTableValue JSHTMLFieldSetElementTableValues[4] =
{
    { "form", (intptr_t)JSHTMLFieldSetElement::FormAttrNum, DontDelete|ReadOnly, 0 },
    { "willValidate", (intptr_t)JSHTMLFieldSetElement::WillValidateAttrNum, DontDelete|ReadOnly, 0 },
    { "constructor", (intptr_t)JSHTMLFieldSetElement::ConstructorAttrNum, DontEnum, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSHTMLFieldSetElementTable = { 7, JSHTMLFieldSetElementTableValues, 0 };

/* Hash table for constructor */

static const HashTableValue JSHTMLFieldSetElementConstructorTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSHTMLFieldSetElementConstructorTable = { 0, JSHTMLFieldSetElementConstructorTableValues, 0 };

class JSHTMLFieldSetElementConstructor : public DOMObject {
public:
    JSHTMLFieldSetElementConstructor(ExecState* exec)
        : DOMObject(exec->lexicalGlobalObject()->objectPrototype())
    {
        putDirect(exec->propertyNames().prototype, JSHTMLFieldSetElementPrototype::self(exec), None);
    }
    virtual bool getOwnPropertySlot(ExecState*, const Identifier&, PropertySlot&);
    JSValue* getValueProperty(ExecState*, int token) const;
    virtual const ClassInfo* classInfo() const { return &s_info; }
    static const ClassInfo s_info;

    virtual bool implementsHasInstance() const { return true; }
};

const ClassInfo JSHTMLFieldSetElementConstructor::s_info = { "HTMLFieldSetElementConstructor", 0, &JSHTMLFieldSetElementConstructorTable, 0 };

bool JSHTMLFieldSetElementConstructor::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSHTMLFieldSetElementConstructor, DOMObject>(exec, &JSHTMLFieldSetElementConstructorTable, this, propertyName, slot);
}

JSValue* JSHTMLFieldSetElementConstructor::getValueProperty(ExecState* exec, int token) const
{
    // The token is the numeric value of its associated constant
    return jsNumber(exec, token);
}

/* Hash table for prototype */

static const HashTableValue JSHTMLFieldSetElementPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSHTMLFieldSetElementPrototypeTable = { 0, JSHTMLFieldSetElementPrototypeTableValues, 0 };

const ClassInfo JSHTMLFieldSetElementPrototype::s_info = { "HTMLFieldSetElementPrototype", 0, &JSHTMLFieldSetElementPrototypeTable, 0 };

JSObject* JSHTMLFieldSetElementPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSHTMLFieldSetElement.prototype]]");
    return JSC::cacheGlobalObject<JSHTMLFieldSetElementPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSHTMLFieldSetElement::s_info = { "HTMLFieldSetElement", &JSHTMLElement::s_info, &JSHTMLFieldSetElementTable , 0 };

JSHTMLFieldSetElement::JSHTMLFieldSetElement(JSObject* prototype, HTMLFieldSetElement* impl)
    : JSHTMLElement(prototype, impl)
{
}

bool JSHTMLFieldSetElement::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSHTMLFieldSetElement, Base>(exec, &JSHTMLFieldSetElementTable, this, propertyName, slot);
}

JSValue* JSHTMLFieldSetElement::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case FormAttrNum: {
        HTMLFieldSetElement* imp = static_cast<HTMLFieldSetElement*>(impl());
        return toJS(exec, WTF::getPtr(imp->form()));
    }
    case WillValidateAttrNum: {
        HTMLFieldSetElement* imp = static_cast<HTMLFieldSetElement*>(impl());
        return jsBoolean(imp->willValidate());
    }
    case ConstructorAttrNum:
        return getConstructor(exec);
    }
    return 0;
}

JSValue* JSHTMLFieldSetElement::getConstructor(ExecState* exec)
{
    static const Identifier* constructorIdentifier = new Identifier(exec, "[[HTMLFieldSetElement.constructor]]");
    return JSC::cacheGlobalObject<JSHTMLFieldSetElementConstructor>(exec, *constructorIdentifier);
}


}
