/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSSQLResultSetRowList.h"

#include <wtf/GetPtr.h>

#include "SQLResultSetRowList.h"

#include <kjs/Error.h>
#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSQLResultSetRowList)

/* Hash table */

static const HashTableValue JSSQLResultSetRowListTableValues[2] =
{
    { "length", (intptr_t)JSSQLResultSetRowList::LengthAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSQLResultSetRowListTable = { 0, JSSQLResultSetRowListTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSQLResultSetRowListPrototypeTableValues[2] =
{
    { "item", (intptr_t)jsSQLResultSetRowListPrototypeFunctionItem, DontDelete|Function, 1 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSQLResultSetRowListPrototypeTable = { 0, JSSQLResultSetRowListPrototypeTableValues, 0 };

const ClassInfo JSSQLResultSetRowListPrototype::s_info = { "SQLResultSetRowListPrototype", 0, &JSSQLResultSetRowListPrototypeTable, 0 };

JSObject* JSSQLResultSetRowListPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSQLResultSetRowList.prototype]]");
    return JSC::cacheGlobalObject<JSSQLResultSetRowListPrototype>(exec, *prototypeIdentifier);
}

bool JSSQLResultSetRowListPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticFunctionSlot<JSObject>(exec, &JSSQLResultSetRowListPrototypeTable, this, propertyName, slot);
}

const ClassInfo JSSQLResultSetRowList::s_info = { "SQLResultSetRowList", 0, &JSSQLResultSetRowListTable , 0 };

JSSQLResultSetRowList::JSSQLResultSetRowList(JSObject* prototype, SQLResultSetRowList* impl)
    : DOMObject(prototype)
    , m_impl(impl)
{
}

JSSQLResultSetRowList::~JSSQLResultSetRowList()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSQLResultSetRowList::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSQLResultSetRowList, Base>(exec, &JSSQLResultSetRowListTable, this, propertyName, slot);
}

JSValue* JSSQLResultSetRowList::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case LengthAttrNum: {
        SQLResultSetRowList* imp = static_cast<SQLResultSetRowList*>(impl());
        return jsNumber(exec, imp->length());
    }
    }
    return 0;
}

JSValue* jsSQLResultSetRowListPrototypeFunctionItem(ExecState* exec, JSObject*, JSValue* thisValue, const ArgList& args)
{
    if (!thisValue->isObject(&JSSQLResultSetRowList::s_info))
        return throwError(exec, TypeError);
    JSSQLResultSetRowList* castedThisObj = static_cast<JSSQLResultSetRowList*>(thisValue);
    return castedThisObj->item(exec, args);
}

JSC::JSValue* toJS(JSC::ExecState* exec, SQLResultSetRowList* obj)
{
    return cacheDOMObject<SQLResultSetRowList, JSSQLResultSetRowList, JSSQLResultSetRowListPrototype>(exec, obj);
}
SQLResultSetRowList* toSQLResultSetRowList(JSC::JSValue* val)
{
    return val->isObject(&JSSQLResultSetRowList::s_info) ? static_cast<JSSQLResultSetRowList*>(val)->impl() : 0;
}

}
