/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSSQLTransaction.h"

#include <wtf/GetPtr.h>

#include "SQLTransaction.h"

#include <kjs/Error.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSQLTransaction)

/* Hash table for prototype */

static const HashTableValue JSSQLTransactionPrototypeTableValues[2] =
{
    { "executeSql", (intptr_t)jsSQLTransactionPrototypeFunctionExecuteSql, DontDelete|Function, 4 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSQLTransactionPrototypeTable = { 0, JSSQLTransactionPrototypeTableValues, 0 };

const ClassInfo JSSQLTransactionPrototype::s_info = { "SQLTransactionPrototype", 0, &JSSQLTransactionPrototypeTable, 0 };

JSObject* JSSQLTransactionPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSQLTransaction.prototype]]");
    return JSC::cacheGlobalObject<JSSQLTransactionPrototype>(exec, *prototypeIdentifier);
}

bool JSSQLTransactionPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticFunctionSlot<JSObject>(exec, &JSSQLTransactionPrototypeTable, this, propertyName, slot);
}

const ClassInfo JSSQLTransaction::s_info = { "SQLTransaction", 0, 0 , 0 };

JSSQLTransaction::JSSQLTransaction(JSObject* prototype, SQLTransaction* impl)
    : DOMObject(prototype)
    , m_impl(impl)
{
}

JSSQLTransaction::~JSSQLTransaction()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

JSValue* jsSQLTransactionPrototypeFunctionExecuteSql(ExecState* exec, JSObject*, JSValue* thisValue, const ArgList& args)
{
    if (!thisValue->isObject(&JSSQLTransaction::s_info))
        return throwError(exec, TypeError);
    JSSQLTransaction* castedThisObj = static_cast<JSSQLTransaction*>(thisValue);
    return castedThisObj->executeSql(exec, args);
}

JSC::JSValue* toJS(JSC::ExecState* exec, SQLTransaction* obj)
{
    return cacheDOMObject<SQLTransaction, JSSQLTransaction, JSSQLTransactionPrototype>(exec, obj);
}
SQLTransaction* toSQLTransaction(JSC::JSValue* val)
{
    return val->isObject(&JSSQLTransaction::s_info) ? static_cast<JSSQLTransaction*>(val)->impl() : 0;
}

}
