/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedAngle.h"

#include <wtf/GetPtr.h>

#include "JSSVGAngle.h"
#include "SVGAngle.h"


using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedAngle)

/* Hash table */

static const HashTableValue JSSVGAnimatedAngleTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedAngle::BaseValAttrNum, DontDelete|ReadOnly, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedAngle::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedAngleTable = { 1, JSSVGAnimatedAngleTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedAnglePrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedAnglePrototypeTable = { 0, JSSVGAnimatedAnglePrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedAnglePrototype::s_info = { "SVGAnimatedAnglePrototype", 0, &JSSVGAnimatedAnglePrototypeTable, 0 };

JSObject* JSSVGAnimatedAnglePrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedAngle.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedAnglePrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedAngle::s_info = { "SVGAnimatedAngle", 0, &JSSVGAnimatedAngleTable , 0 };

JSSVGAnimatedAngle::JSSVGAnimatedAngle(JSObject* prototype, SVGAnimatedAngle* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedAngle::~JSSVGAnimatedAngle()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedAngle::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedAngle, Base>(exec, &JSSVGAnimatedAngleTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedAngle::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedAngle* imp = static_cast<SVGAnimatedAngle*>(impl());
        return toJS(exec, WTF::getPtr(imp->baseVal()), context());
    }
    case AnimValAttrNum: {
        SVGAnimatedAngle* imp = static_cast<SVGAnimatedAngle*>(impl());
        return toJS(exec, WTF::getPtr(imp->animVal()), context());
    }
    }
    return 0;
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedAngle* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedAngle, JSSVGAnimatedAngle, JSSVGAnimatedAnglePrototype>(exec, obj, context);
}
SVGAnimatedAngle* toSVGAnimatedAngle(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedAngle::s_info) ? static_cast<JSSVGAnimatedAngle*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
