/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedEnumeration.h"

#include <wtf/GetPtr.h>


#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedEnumeration)

/* Hash table */

static const HashTableValue JSSVGAnimatedEnumerationTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedEnumeration::BaseValAttrNum, DontDelete, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedEnumeration::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedEnumerationTable = { 1, JSSVGAnimatedEnumerationTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedEnumerationPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedEnumerationPrototypeTable = { 0, JSSVGAnimatedEnumerationPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedEnumerationPrototype::s_info = { "SVGAnimatedEnumerationPrototype", 0, &JSSVGAnimatedEnumerationPrototypeTable, 0 };

JSObject* JSSVGAnimatedEnumerationPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedEnumeration.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedEnumerationPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedEnumeration::s_info = { "SVGAnimatedEnumeration", 0, &JSSVGAnimatedEnumerationTable , 0 };

JSSVGAnimatedEnumeration::JSSVGAnimatedEnumeration(JSObject* prototype, SVGAnimatedEnumeration* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedEnumeration::~JSSVGAnimatedEnumeration()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedEnumeration::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedEnumeration, Base>(exec, &JSSVGAnimatedEnumerationTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedEnumeration::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedEnumeration* imp = static_cast<SVGAnimatedEnumeration*>(impl());
        return jsNumber(exec, imp->baseVal());
    }
    case AnimValAttrNum: {
        SVGAnimatedEnumeration* imp = static_cast<SVGAnimatedEnumeration*>(impl());
        return jsNumber(exec, imp->animVal());
    }
    }
    return 0;
}

void JSSVGAnimatedEnumeration::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGAnimatedEnumeration, Base>(exec, propertyName, value, &JSSVGAnimatedEnumerationTable, this, slot);
}

void JSSVGAnimatedEnumeration::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedEnumeration* imp = static_cast<SVGAnimatedEnumeration*>(impl());
        imp->setBaseVal(value->toInt32(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    }
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedEnumeration* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedEnumeration, JSSVGAnimatedEnumeration, JSSVGAnimatedEnumerationPrototype>(exec, obj, context);
}
SVGAnimatedEnumeration* toSVGAnimatedEnumeration(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedEnumeration::s_info) ? static_cast<JSSVGAnimatedEnumeration*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
