/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedInteger.h"

#include <wtf/GetPtr.h>


#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedInteger)

/* Hash table */

static const HashTableValue JSSVGAnimatedIntegerTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedInteger::BaseValAttrNum, DontDelete, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedInteger::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedIntegerTable = { 1, JSSVGAnimatedIntegerTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedIntegerPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedIntegerPrototypeTable = { 0, JSSVGAnimatedIntegerPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedIntegerPrototype::s_info = { "SVGAnimatedIntegerPrototype", 0, &JSSVGAnimatedIntegerPrototypeTable, 0 };

JSObject* JSSVGAnimatedIntegerPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedInteger.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedIntegerPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedInteger::s_info = { "SVGAnimatedInteger", 0, &JSSVGAnimatedIntegerTable , 0 };

JSSVGAnimatedInteger::JSSVGAnimatedInteger(JSObject* prototype, SVGAnimatedInteger* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedInteger::~JSSVGAnimatedInteger()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedInteger::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedInteger, Base>(exec, &JSSVGAnimatedIntegerTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedInteger::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedInteger* imp = static_cast<SVGAnimatedInteger*>(impl());
        return jsNumber(exec, imp->baseVal());
    }
    case AnimValAttrNum: {
        SVGAnimatedInteger* imp = static_cast<SVGAnimatedInteger*>(impl());
        return jsNumber(exec, imp->animVal());
    }
    }
    return 0;
}

void JSSVGAnimatedInteger::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGAnimatedInteger, Base>(exec, propertyName, value, &JSSVGAnimatedIntegerTable, this, slot);
}

void JSSVGAnimatedInteger::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedInteger* imp = static_cast<SVGAnimatedInteger*>(impl());
        imp->setBaseVal(value->toInt32(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    }
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedInteger* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedInteger, JSSVGAnimatedInteger, JSSVGAnimatedIntegerPrototype>(exec, obj, context);
}
SVGAnimatedInteger* toSVGAnimatedInteger(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedInteger::s_info) ? static_cast<JSSVGAnimatedInteger*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
