/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedLength.h"

#include <wtf/GetPtr.h>

#include "JSSVGLength.h"


using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedLength)

/* Hash table */

static const HashTableValue JSSVGAnimatedLengthTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedLength::BaseValAttrNum, DontDelete|ReadOnly, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedLength::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedLengthTable = { 1, JSSVGAnimatedLengthTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedLengthPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedLengthPrototypeTable = { 0, JSSVGAnimatedLengthPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedLengthPrototype::s_info = { "SVGAnimatedLengthPrototype", 0, &JSSVGAnimatedLengthPrototypeTable, 0 };

JSObject* JSSVGAnimatedLengthPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedLength.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedLengthPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedLength::s_info = { "SVGAnimatedLength", 0, &JSSVGAnimatedLengthTable , 0 };

JSSVGAnimatedLength::JSSVGAnimatedLength(JSObject* prototype, SVGAnimatedLength* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedLength::~JSSVGAnimatedLength()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedLength::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedLength, Base>(exec, &JSSVGAnimatedLengthTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedLength::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedLength* imp = static_cast<SVGAnimatedLength*>(impl());
        return toJS(exec, JSSVGDynamicPODTypeWrapperCache<SVGLength, SVGAnimatedLength>::lookupOrCreateWrapper(imp, &SVGAnimatedLength::baseVal, &SVGAnimatedLength::setBaseVal).get(), context());
    }
    case AnimValAttrNum: {
        SVGAnimatedLength* imp = static_cast<SVGAnimatedLength*>(impl());
        return toJS(exec, JSSVGDynamicPODTypeWrapperCache<SVGLength, SVGAnimatedLength>::lookupOrCreateWrapper(imp, &SVGAnimatedLength::animVal, &SVGAnimatedLength::setAnimVal).get(), context());
    }
    }
    return 0;
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedLength* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedLength, JSSVGAnimatedLength, JSSVGAnimatedLengthPrototype>(exec, obj, context);
}
SVGAnimatedLength* toSVGAnimatedLength(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedLength::s_info) ? static_cast<JSSVGAnimatedLength*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
