/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedLengthList.h"

#include <wtf/GetPtr.h>

#include "JSSVGLengthList.h"
#include "SVGLengthList.h"


using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedLengthList)

/* Hash table */

static const HashTableValue JSSVGAnimatedLengthListTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedLengthList::BaseValAttrNum, DontDelete|ReadOnly, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedLengthList::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedLengthListTable = { 1, JSSVGAnimatedLengthListTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedLengthListPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedLengthListPrototypeTable = { 0, JSSVGAnimatedLengthListPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedLengthListPrototype::s_info = { "SVGAnimatedLengthListPrototype", 0, &JSSVGAnimatedLengthListPrototypeTable, 0 };

JSObject* JSSVGAnimatedLengthListPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedLengthList.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedLengthListPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedLengthList::s_info = { "SVGAnimatedLengthList", 0, &JSSVGAnimatedLengthListTable , 0 };

JSSVGAnimatedLengthList::JSSVGAnimatedLengthList(JSObject* prototype, SVGAnimatedLengthList* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedLengthList::~JSSVGAnimatedLengthList()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedLengthList::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedLengthList, Base>(exec, &JSSVGAnimatedLengthListTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedLengthList::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedLengthList* imp = static_cast<SVGAnimatedLengthList*>(impl());
        return toJS(exec, WTF::getPtr(imp->baseVal()), context());
    }
    case AnimValAttrNum: {
        SVGAnimatedLengthList* imp = static_cast<SVGAnimatedLengthList*>(impl());
        return toJS(exec, WTF::getPtr(imp->animVal()), context());
    }
    }
    return 0;
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedLengthList* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedLengthList, JSSVGAnimatedLengthList, JSSVGAnimatedLengthListPrototype>(exec, obj, context);
}
SVGAnimatedLengthList* toSVGAnimatedLengthList(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedLengthList::s_info) ? static_cast<JSSVGAnimatedLengthList*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
