/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedNumber.h"

#include <wtf/GetPtr.h>


#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedNumber)

/* Hash table */

static const HashTableValue JSSVGAnimatedNumberTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedNumber::BaseValAttrNum, DontDelete, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedNumber::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedNumberTable = { 1, JSSVGAnimatedNumberTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedNumberPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedNumberPrototypeTable = { 0, JSSVGAnimatedNumberPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedNumberPrototype::s_info = { "SVGAnimatedNumberPrototype", 0, &JSSVGAnimatedNumberPrototypeTable, 0 };

JSObject* JSSVGAnimatedNumberPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedNumber.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedNumberPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedNumber::s_info = { "SVGAnimatedNumber", 0, &JSSVGAnimatedNumberTable , 0 };

JSSVGAnimatedNumber::JSSVGAnimatedNumber(JSObject* prototype, SVGAnimatedNumber* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedNumber::~JSSVGAnimatedNumber()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedNumber::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedNumber, Base>(exec, &JSSVGAnimatedNumberTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedNumber::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedNumber* imp = static_cast<SVGAnimatedNumber*>(impl());
        return jsNumber(exec, imp->baseVal());
    }
    case AnimValAttrNum: {
        SVGAnimatedNumber* imp = static_cast<SVGAnimatedNumber*>(impl());
        return jsNumber(exec, imp->animVal());
    }
    }
    return 0;
}

void JSSVGAnimatedNumber::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGAnimatedNumber, Base>(exec, propertyName, value, &JSSVGAnimatedNumberTable, this, slot);
}

void JSSVGAnimatedNumber::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedNumber* imp = static_cast<SVGAnimatedNumber*>(impl());
        imp->setBaseVal(value->toFloat(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    }
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedNumber* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedNumber, JSSVGAnimatedNumber, JSSVGAnimatedNumberPrototype>(exec, obj, context);
}
SVGAnimatedNumber* toSVGAnimatedNumber(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedNumber::s_info) ? static_cast<JSSVGAnimatedNumber*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
