/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedPreserveAspectRatio.h"

#include <wtf/GetPtr.h>

#include "JSSVGPreserveAspectRatio.h"
#include "SVGPreserveAspectRatio.h"


using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedPreserveAspectRatio)

/* Hash table */

static const HashTableValue JSSVGAnimatedPreserveAspectRatioTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedPreserveAspectRatio::BaseValAttrNum, DontDelete|ReadOnly, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedPreserveAspectRatio::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedPreserveAspectRatioTable = { 1, JSSVGAnimatedPreserveAspectRatioTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedPreserveAspectRatioPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedPreserveAspectRatioPrototypeTable = { 0, JSSVGAnimatedPreserveAspectRatioPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedPreserveAspectRatioPrototype::s_info = { "SVGAnimatedPreserveAspectRatioPrototype", 0, &JSSVGAnimatedPreserveAspectRatioPrototypeTable, 0 };

JSObject* JSSVGAnimatedPreserveAspectRatioPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedPreserveAspectRatio.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedPreserveAspectRatioPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedPreserveAspectRatio::s_info = { "SVGAnimatedPreserveAspectRatio", 0, &JSSVGAnimatedPreserveAspectRatioTable , 0 };

JSSVGAnimatedPreserveAspectRatio::JSSVGAnimatedPreserveAspectRatio(JSObject* prototype, SVGAnimatedPreserveAspectRatio* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedPreserveAspectRatio::~JSSVGAnimatedPreserveAspectRatio()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedPreserveAspectRatio::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedPreserveAspectRatio, Base>(exec, &JSSVGAnimatedPreserveAspectRatioTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedPreserveAspectRatio::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedPreserveAspectRatio* imp = static_cast<SVGAnimatedPreserveAspectRatio*>(impl());
        return toJS(exec, WTF::getPtr(imp->baseVal()), context());
    }
    case AnimValAttrNum: {
        SVGAnimatedPreserveAspectRatio* imp = static_cast<SVGAnimatedPreserveAspectRatio*>(impl());
        return toJS(exec, WTF::getPtr(imp->animVal()), context());
    }
    }
    return 0;
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedPreserveAspectRatio* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedPreserveAspectRatio, JSSVGAnimatedPreserveAspectRatio, JSSVGAnimatedPreserveAspectRatioPrototype>(exec, obj, context);
}
SVGAnimatedPreserveAspectRatio* toSVGAnimatedPreserveAspectRatio(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedPreserveAspectRatio::s_info) ? static_cast<JSSVGAnimatedPreserveAspectRatio*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
