/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedRect.h"

#include <wtf/GetPtr.h>

#include "FloatRect.h"
#include "JSSVGRect.h"


using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedRect)

/* Hash table */

static const HashTableValue JSSVGAnimatedRectTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedRect::BaseValAttrNum, DontDelete|ReadOnly, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedRect::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedRectTable = { 1, JSSVGAnimatedRectTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedRectPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedRectPrototypeTable = { 0, JSSVGAnimatedRectPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedRectPrototype::s_info = { "SVGAnimatedRectPrototype", 0, &JSSVGAnimatedRectPrototypeTable, 0 };

JSObject* JSSVGAnimatedRectPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedRect.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedRectPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedRect::s_info = { "SVGAnimatedRect", 0, &JSSVGAnimatedRectTable , 0 };

JSSVGAnimatedRect::JSSVGAnimatedRect(JSObject* prototype, SVGAnimatedRect* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedRect::~JSSVGAnimatedRect()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedRect::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedRect, Base>(exec, &JSSVGAnimatedRectTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedRect::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedRect* imp = static_cast<SVGAnimatedRect*>(impl());
        return toJS(exec, JSSVGDynamicPODTypeWrapperCache<FloatRect, SVGAnimatedRect>::lookupOrCreateWrapper(imp, &SVGAnimatedRect::baseVal, &SVGAnimatedRect::setBaseVal).get(), context());
    }
    case AnimValAttrNum: {
        SVGAnimatedRect* imp = static_cast<SVGAnimatedRect*>(impl());
        return toJS(exec, JSSVGDynamicPODTypeWrapperCache<FloatRect, SVGAnimatedRect>::lookupOrCreateWrapper(imp, &SVGAnimatedRect::animVal, &SVGAnimatedRect::setAnimVal).get(), context());
    }
    }
    return 0;
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedRect* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedRect, JSSVGAnimatedRect, JSSVGAnimatedRectPrototype>(exec, obj, context);
}
SVGAnimatedRect* toSVGAnimatedRect(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedRect::s_info) ? static_cast<JSSVGAnimatedRect*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
