/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedString.h"

#include <wtf/GetPtr.h>

#include "KURL.h"
#include "PlatformString.h"

#include <kjs/JSString.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGAnimatedString)

/* Hash table */

static const HashTableValue JSSVGAnimatedStringTableValues[3] =
{
    { "baseVal", (intptr_t)JSSVGAnimatedString::BaseValAttrNum, DontDelete, 0 },
    { "animVal", (intptr_t)JSSVGAnimatedString::AnimValAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedStringTable = { 1, JSSVGAnimatedStringTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGAnimatedStringPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedStringPrototypeTable = { 0, JSSVGAnimatedStringPrototypeTableValues, 0 };

const ClassInfo JSSVGAnimatedStringPrototype::s_info = { "SVGAnimatedStringPrototype", 0, &JSSVGAnimatedStringPrototypeTable, 0 };

JSObject* JSSVGAnimatedStringPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGAnimatedString.prototype]]");
    return JSC::cacheGlobalObject<JSSVGAnimatedStringPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGAnimatedString::s_info = { "SVGAnimatedString", 0, &JSSVGAnimatedStringTable , 0 };

JSSVGAnimatedString::JSSVGAnimatedString(JSObject* prototype, SVGAnimatedString* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGAnimatedString::~JSSVGAnimatedString()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGAnimatedString::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedString, Base>(exec, &JSSVGAnimatedStringTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedString::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedString* imp = static_cast<SVGAnimatedString*>(impl());
        return jsString(exec, imp->baseVal());
    }
    case AnimValAttrNum: {
        SVGAnimatedString* imp = static_cast<SVGAnimatedString*>(impl());
        return jsString(exec, imp->animVal());
    }
    }
    return 0;
}

void JSSVGAnimatedString::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGAnimatedString, Base>(exec, propertyName, value, &JSSVGAnimatedStringTable, this, slot);
}

void JSSVGAnimatedString::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedString* imp = static_cast<SVGAnimatedString*>(impl());
        imp->setBaseVal(value->toString(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    }
}

JSC::JSValue* toJS(JSC::ExecState* exec, SVGAnimatedString* obj, SVGElement* context)
{
    return cacheSVGDOMObject<SVGAnimatedString, JSSVGAnimatedString, JSSVGAnimatedStringPrototype>(exec, obj, context);
}
SVGAnimatedString* toSVGAnimatedString(JSC::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedString::s_info) ? static_cast<JSSVGAnimatedString*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
