/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGDocument.h"

#include <wtf/GetPtr.h>

#include "Event.h"
#include "JSEvent.h"
#include "JSSVGSVGElement.h"
#include "SVGDocument.h"
#include "SVGSVGElement.h"

#include <kjs/Error.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGDocument)

/* Hash table */

static const HashTableValue JSSVGDocumentTableValues[2] =
{
    { "rootElement", (intptr_t)JSSVGDocument::RootElementAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGDocumentTable = { 0, JSSVGDocumentTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGDocumentPrototypeTableValues[2] =
{
    { "createEvent", (intptr_t)jsSVGDocumentPrototypeFunctionCreateEvent, DontDelete|Function, 1 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGDocumentPrototypeTable = { 0, JSSVGDocumentPrototypeTableValues, 0 };

const ClassInfo JSSVGDocumentPrototype::s_info = { "SVGDocumentPrototype", 0, &JSSVGDocumentPrototypeTable, 0 };

JSObject* JSSVGDocumentPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGDocument.prototype]]");
    return JSC::cacheGlobalObject<JSSVGDocumentPrototype>(exec, *prototypeIdentifier);
}

bool JSSVGDocumentPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticFunctionSlot<JSObject>(exec, &JSSVGDocumentPrototypeTable, this, propertyName, slot);
}

const ClassInfo JSSVGDocument::s_info = { "SVGDocument", &JSDocument::s_info, &JSSVGDocumentTable , 0 };

JSSVGDocument::JSSVGDocument(JSObject* prototype, SVGDocument* impl)
    : JSDocument(prototype, impl)
{
}

bool JSSVGDocument::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGDocument, Base>(exec, &JSSVGDocumentTable, this, propertyName, slot);
}

JSValue* JSSVGDocument::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case RootElementAttrNum: {
        SVGDocument* imp = static_cast<SVGDocument*>(impl());
        return toJS(exec, WTF::getPtr(imp->rootElement()));
    }
    }
    return 0;
}

JSValue* jsSVGDocumentPrototypeFunctionCreateEvent(ExecState* exec, JSObject*, JSValue* thisValue, const ArgList& args)
{
    if (!thisValue->isObject(&JSSVGDocument::s_info))
        return throwError(exec, TypeError);
    JSSVGDocument* castedThisObj = static_cast<JSSVGDocument*>(thisValue);
    SVGDocument* imp = static_cast<SVGDocument*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    const UString& eventType = args.at(exec, 0)->toString(exec);


    JSC::JSValue* result = toJS(exec, WTF::getPtr(imp->createEvent(eventType, ec)));
    setDOMException(exec, ec);
    return result;
}


}

#endif // ENABLE(SVG)
