/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGElement.h"

#include <wtf/GetPtr.h>

#include "JSSVGElement.h"
#include "JSSVGSVGElement.h"
#include "KURL.h"
#include "SVGElement.h"
#include "SVGSVGElement.h"

#include <kjs/JSString.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGElement)

/* Hash table */

static const HashTableValue JSSVGElementTableValues[5] =
{
    { "id", (intptr_t)JSSVGElement::IdAttrNum, DontDelete, 0 },
    { "xmlbase", (intptr_t)JSSVGElement::XmlbaseAttrNum, DontDelete, 0 },
    { "ownerSVGElement", (intptr_t)JSSVGElement::OwnerSVGElementAttrNum, DontDelete|ReadOnly, 0 },
    { "viewportElement", (intptr_t)JSSVGElement::ViewportElementAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGElementTable = { 15, JSSVGElementTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGElementPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGElementPrototypeTable = { 0, JSSVGElementPrototypeTableValues, 0 };

const ClassInfo JSSVGElementPrototype::s_info = { "SVGElementPrototype", 0, &JSSVGElementPrototypeTable, 0 };

JSObject* JSSVGElementPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGElement.prototype]]");
    return JSC::cacheGlobalObject<JSSVGElementPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGElement::s_info = { "SVGElement", &JSElement::s_info, &JSSVGElementTable , 0 };

JSSVGElement::JSSVGElement(JSObject* prototype, SVGElement* impl)
    : JSElement(prototype, impl)
{
}

bool JSSVGElement::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGElement, Base>(exec, &JSSVGElementTable, this, propertyName, slot);
}

JSValue* JSSVGElement::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case IdAttrNum: {
        SVGElement* imp = static_cast<SVGElement*>(impl());
        return jsString(exec, imp->id());
    }
    case XmlbaseAttrNum: {
        SVGElement* imp = static_cast<SVGElement*>(impl());
        return jsString(exec, imp->xmlbase());
    }
    case OwnerSVGElementAttrNum: {
        SVGElement* imp = static_cast<SVGElement*>(impl());
        return toJS(exec, WTF::getPtr(imp->ownerSVGElement()));
    }
    case ViewportElementAttrNum: {
        SVGElement* imp = static_cast<SVGElement*>(impl());
        return toJS(exec, WTF::getPtr(imp->viewportElement()));
    }
    }
    return 0;
}

void JSSVGElement::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGElement, Base>(exec, propertyName, value, &JSSVGElementTable, this, slot);
}

void JSSVGElement::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case IdAttrNum: {
        SVGElement* imp = static_cast<SVGElement*>(impl());
        ExceptionCode ec = 0;
        imp->setId(valueToStringWithNullCheck(exec, value), ec);
        setDOMException(exec, ec);
        break;
    }
    case XmlbaseAttrNum: {
        SVGElement* imp = static_cast<SVGElement*>(impl());
        ExceptionCode ec = 0;
        imp->setXmlbase(valueToStringWithNullCheck(exec, value), ec);
        setDOMException(exec, ec);
        break;
    }
    }
}

SVGElement* toSVGElement(JSC::JSValue* val)
{
    return val->isObject(&JSSVGElement::s_info) ? static_cast<JSSVGElement*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
