/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGMarkerElement.h"

#include <wtf/GetPtr.h>

#include "CSSMutableStyleDeclaration.h"
#include "CSSStyleDeclaration.h"
#include "CSSValue.h"
#include "JSCSSStyleDeclaration.h"
#include "JSCSSValue.h"
#include "JSSVGAngle.h"
#include "JSSVGAnimatedAngle.h"
#include "JSSVGAnimatedBoolean.h"
#include "JSSVGAnimatedEnumeration.h"
#include "JSSVGAnimatedLength.h"
#include "JSSVGAnimatedPreserveAspectRatio.h"
#include "JSSVGAnimatedRect.h"
#include "JSSVGAnimatedString.h"
#include "KURL.h"
#include "SVGMarkerElement.h"

#include <kjs/Error.h>
#include <kjs/JSNumberCell.h>
#include <kjs/JSString.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGMarkerElement)

/* Hash table */

static const HashTableValue JSSVGMarkerElementTableValues[16] =
{
    { "refX", (intptr_t)JSSVGMarkerElement::RefXAttrNum, DontDelete|ReadOnly, 0 },
    { "refY", (intptr_t)JSSVGMarkerElement::RefYAttrNum, DontDelete|ReadOnly, 0 },
    { "markerUnits", (intptr_t)JSSVGMarkerElement::MarkerUnitsAttrNum, DontDelete|ReadOnly, 0 },
    { "markerWidth", (intptr_t)JSSVGMarkerElement::MarkerWidthAttrNum, DontDelete|ReadOnly, 0 },
    { "markerHeight", (intptr_t)JSSVGMarkerElement::MarkerHeightAttrNum, DontDelete|ReadOnly, 0 },
    { "orientType", (intptr_t)JSSVGMarkerElement::OrientTypeAttrNum, DontDelete|ReadOnly, 0 },
    { "orientAngle", (intptr_t)JSSVGMarkerElement::OrientAngleAttrNum, DontDelete|ReadOnly, 0 },
    { "xmllang", (intptr_t)JSSVGMarkerElement::XmllangAttrNum, DontDelete, 0 },
    { "xmlspace", (intptr_t)JSSVGMarkerElement::XmlspaceAttrNum, DontDelete, 0 },
    { "externalResourcesRequired", (intptr_t)JSSVGMarkerElement::ExternalResourcesRequiredAttrNum, DontDelete|ReadOnly, 0 },
    { "className", (intptr_t)JSSVGMarkerElement::ClassNameAttrNum, DontDelete|ReadOnly, 0 },
    { "style", (intptr_t)JSSVGMarkerElement::StyleAttrNum, DontDelete|ReadOnly, 0 },
    { "viewBox", (intptr_t)JSSVGMarkerElement::ViewBoxAttrNum, DontDelete|ReadOnly, 0 },
    { "preserveAspectRatio", (intptr_t)JSSVGMarkerElement::PreserveAspectRatioAttrNum, DontDelete|ReadOnly, 0 },
    { "constructor", (intptr_t)JSSVGMarkerElement::ConstructorAttrNum, DontEnum, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGMarkerElementTable = { 63, JSSVGMarkerElementTableValues, 0 };

/* Hash table for constructor */

static const HashTableValue JSSVGMarkerElementConstructorTableValues[7] =
{
    { "SVG_MARKERUNITS_UNKNOWN", (intptr_t)0, DontDelete|ReadOnly, 0 },
    { "SVG_MARKERUNITS_USERSPACEONUSE", (intptr_t)1, DontDelete|ReadOnly, 0 },
    { "SVG_MARKERUNITS_STROKEWIDTH", (intptr_t)2, DontDelete|ReadOnly, 0 },
    { "SVG_MARKER_ORIENT_UNKNOWN", (intptr_t)0, DontDelete|ReadOnly, 0 },
    { "SVG_MARKER_ORIENT_AUTO", (intptr_t)1, DontDelete|ReadOnly, 0 },
    { "SVG_MARKER_ORIENT_ANGLE", (intptr_t)2, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGMarkerElementConstructorTable = { 15, JSSVGMarkerElementConstructorTableValues, 0 };

class JSSVGMarkerElementConstructor : public DOMObject {
public:
    JSSVGMarkerElementConstructor(ExecState* exec)
        : DOMObject(exec->lexicalGlobalObject()->objectPrototype())
    {
        putDirect(exec->propertyNames().prototype, JSSVGMarkerElementPrototype::self(exec), None);
    }
    virtual bool getOwnPropertySlot(ExecState*, const Identifier&, PropertySlot&);
    JSValue* getValueProperty(ExecState*, int token) const;
    virtual const ClassInfo* classInfo() const { return &s_info; }
    static const ClassInfo s_info;

    virtual bool implementsHasInstance() const { return true; }
};

const ClassInfo JSSVGMarkerElementConstructor::s_info = { "SVGMarkerElementConstructor", 0, &JSSVGMarkerElementConstructorTable, 0 };

bool JSSVGMarkerElementConstructor::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGMarkerElementConstructor, DOMObject>(exec, &JSSVGMarkerElementConstructorTable, this, propertyName, slot);
}

JSValue* JSSVGMarkerElementConstructor::getValueProperty(ExecState* exec, int token) const
{
    // The token is the numeric value of its associated constant
    return jsNumber(exec, token);
}

/* Hash table for prototype */

static const HashTableValue JSSVGMarkerElementPrototypeTableValues[10] =
{
    { "SVG_MARKERUNITS_UNKNOWN", (intptr_t)0, DontDelete|ReadOnly, 0 },
    { "SVG_MARKERUNITS_USERSPACEONUSE", (intptr_t)1, DontDelete|ReadOnly, 0 },
    { "SVG_MARKERUNITS_STROKEWIDTH", (intptr_t)2, DontDelete|ReadOnly, 0 },
    { "SVG_MARKER_ORIENT_UNKNOWN", (intptr_t)0, DontDelete|ReadOnly, 0 },
    { "SVG_MARKER_ORIENT_AUTO", (intptr_t)1, DontDelete|ReadOnly, 0 },
    { "SVG_MARKER_ORIENT_ANGLE", (intptr_t)2, DontDelete|ReadOnly, 0 },
    { "setOrientToAuto", (intptr_t)jsSVGMarkerElementPrototypeFunctionSetOrientToAuto, DontDelete|Function, 0 },
    { "setOrientToAngle", (intptr_t)jsSVGMarkerElementPrototypeFunctionSetOrientToAngle, DontDelete|Function, 1 },
    { "getPresentationAttribute", (intptr_t)jsSVGMarkerElementPrototypeFunctionGetPresentationAttribute, DontDelete|Function, 1 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGMarkerElementPrototypeTable = { 31, JSSVGMarkerElementPrototypeTableValues, 0 };

const ClassInfo JSSVGMarkerElementPrototype::s_info = { "SVGMarkerElementPrototype", 0, &JSSVGMarkerElementPrototypeTable, 0 };

JSObject* JSSVGMarkerElementPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGMarkerElement.prototype]]");
    return JSC::cacheGlobalObject<JSSVGMarkerElementPrototype>(exec, *prototypeIdentifier);
}

bool JSSVGMarkerElementPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticPropertySlot<JSSVGMarkerElementPrototype, JSObject>(exec, &JSSVGMarkerElementPrototypeTable, this, propertyName, slot);
}

JSValue* JSSVGMarkerElementPrototype::getValueProperty(ExecState* exec, int token) const
{
    // The token is the numeric value of its associated constant
    return jsNumber(exec, token);
}

const ClassInfo JSSVGMarkerElement::s_info = { "SVGMarkerElement", &JSSVGElement::s_info, &JSSVGMarkerElementTable , 0 };

JSSVGMarkerElement::JSSVGMarkerElement(JSObject* prototype, SVGMarkerElement* impl)
    : JSSVGElement(prototype, impl)
{
}

bool JSSVGMarkerElement::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGMarkerElement, Base>(exec, &JSSVGMarkerElementTable, this, propertyName, slot);
}

JSValue* JSSVGMarkerElement::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case RefXAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->refXAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case RefYAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->refYAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case MarkerUnitsAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedEnumeration> obj = imp->markerUnitsAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case MarkerWidthAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->markerWidthAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case MarkerHeightAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->markerHeightAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case OrientTypeAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedEnumeration> obj = imp->orientTypeAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case OrientAngleAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedAngle> obj = imp->orientAngleAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case XmllangAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        return jsString(exec, imp->xmllang());
    }
    case XmlspaceAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        return jsString(exec, imp->xmlspace());
    }
    case ExternalResourcesRequiredAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedBoolean> obj = imp->externalResourcesRequiredAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case ClassNameAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedString> obj = imp->classNameAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case StyleAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        return toJS(exec, WTF::getPtr(imp->style()));
    }
    case ViewBoxAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedRect> obj = imp->viewBoxAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case PreserveAspectRatioAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        RefPtr<SVGAnimatedPreserveAspectRatio> obj = imp->preserveAspectRatioAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case ConstructorAttrNum:
        return getConstructor(exec);
    }
    return 0;
}

void JSSVGMarkerElement::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGMarkerElement, Base>(exec, propertyName, value, &JSSVGMarkerElementTable, this, slot);
}

void JSSVGMarkerElement::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case XmllangAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        imp->setXmllang(value->toString(exec));
        break;
    }
    case XmlspaceAttrNum: {
        SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(impl());
        imp->setXmlspace(value->toString(exec));
        break;
    }
    }
}

JSValue* JSSVGMarkerElement::getConstructor(ExecState* exec)
{
    static const Identifier* constructorIdentifier = new Identifier(exec, "[[SVGMarkerElement.constructor]]");
    return JSC::cacheGlobalObject<JSSVGMarkerElementConstructor>(exec, *constructorIdentifier);
}

JSValue* jsSVGMarkerElementPrototypeFunctionSetOrientToAuto(ExecState* exec, JSObject*, JSValue* thisValue, const ArgList& args)
{
    if (!thisValue->isObject(&JSSVGMarkerElement::s_info))
        return throwError(exec, TypeError);
    JSSVGMarkerElement* castedThisObj = static_cast<JSSVGMarkerElement*>(thisValue);
    SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(castedThisObj->impl());

    imp->setOrientToAuto();
    return jsUndefined();
}

JSValue* jsSVGMarkerElementPrototypeFunctionSetOrientToAngle(ExecState* exec, JSObject*, JSValue* thisValue, const ArgList& args)
{
    if (!thisValue->isObject(&JSSVGMarkerElement::s_info))
        return throwError(exec, TypeError);
    JSSVGMarkerElement* castedThisObj = static_cast<JSSVGMarkerElement*>(thisValue);
    SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(castedThisObj->impl());
    SVGAngle* angle = toSVGAngle(args.at(exec, 0));

    imp->setOrientToAngle(angle);
    return jsUndefined();
}

JSValue* jsSVGMarkerElementPrototypeFunctionGetPresentationAttribute(ExecState* exec, JSObject*, JSValue* thisValue, const ArgList& args)
{
    if (!thisValue->isObject(&JSSVGMarkerElement::s_info))
        return throwError(exec, TypeError);
    JSSVGMarkerElement* castedThisObj = static_cast<JSSVGMarkerElement*>(thisValue);
    SVGMarkerElement* imp = static_cast<SVGMarkerElement*>(castedThisObj->impl());
    const UString& name = args.at(exec, 0)->toString(exec);


    JSC::JSValue* result = toJS(exec, WTF::getPtr(imp->getPresentationAttribute(name)));
    return result;
}


}

#endif // ENABLE(SVG)
