/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGNumber.h"

#include <wtf/GetPtr.h>


#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGNumber)

/* Hash table */

static const HashTableValue JSSVGNumberTableValues[2] =
{
    { "value", (intptr_t)JSSVGNumber::ValueAttrNum, DontDelete, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGNumberTable = { 0, JSSVGNumberTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGNumberPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGNumberPrototypeTable = { 0, JSSVGNumberPrototypeTableValues, 0 };

const ClassInfo JSSVGNumberPrototype::s_info = { "SVGNumberPrototype", 0, &JSSVGNumberPrototypeTable, 0 };

JSObject* JSSVGNumberPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGNumber.prototype]]");
    return JSC::cacheGlobalObject<JSSVGNumberPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGNumber::s_info = { "SVGNumber", 0, &JSSVGNumberTable , 0 };

JSSVGNumber::JSSVGNumber(JSObject* prototype, JSSVGPODTypeWrapper<float>* impl, SVGElement* context)
    : DOMObject(prototype)
    , m_context(context)
    , m_impl(impl)
{
}

JSSVGNumber::~JSSVGNumber()
{
    ScriptInterpreter::forgetDOMObject(m_impl.get());

}

bool JSSVGNumber::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGNumber, Base>(exec, &JSSVGNumberTable, this, propertyName, slot);
}

JSValue* JSSVGNumber::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case ValueAttrNum: {
        float imp(*impl());
        return jsNumber(exec, imp);
    }
    }
    return 0;
}

void JSSVGNumber::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGNumber, Base>(exec, propertyName, value, &JSSVGNumberTable, this, slot);
}

void JSSVGNumber::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case ValueAttrNum: {
        float imp(*impl());
        imp = value->toFloat(exec);
        m_impl->commitChange(imp, context());
        break;
    }
    }
}

JSC::JSValue* toJS(JSC::ExecState* exec, JSSVGPODTypeWrapper<float>* obj, SVGElement* context)
{
    return cacheSVGDOMObject<JSSVGPODTypeWrapper<float>, JSSVGNumber, JSSVGNumberPrototype>(exec, obj, context);
}
float toSVGNumber(JSC::JSValue* val)
{
    return val->isObject(&JSSVGNumber::s_info) ? (float) *static_cast<JSSVGNumber*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
