/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGPathSegArcAbs.h"

#include <wtf/GetPtr.h>

#include "SVGPathSegArc.h"

#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGPathSegArcAbs)

/* Hash table */

static const HashTableValue JSSVGPathSegArcAbsTableValues[8] =
{
    { "x", (intptr_t)JSSVGPathSegArcAbs::XAttrNum, DontDelete, 0 },
    { "y", (intptr_t)JSSVGPathSegArcAbs::YAttrNum, DontDelete, 0 },
    { "r1", (intptr_t)JSSVGPathSegArcAbs::R1AttrNum, DontDelete, 0 },
    { "r2", (intptr_t)JSSVGPathSegArcAbs::R2AttrNum, DontDelete, 0 },
    { "angle", (intptr_t)JSSVGPathSegArcAbs::AngleAttrNum, DontDelete, 0 },
    { "largeArcFlag", (intptr_t)JSSVGPathSegArcAbs::LargeArcFlagAttrNum, DontDelete, 0 },
    { "sweepFlag", (intptr_t)JSSVGPathSegArcAbs::SweepFlagAttrNum, DontDelete, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGPathSegArcAbsTable = { 15, JSSVGPathSegArcAbsTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGPathSegArcAbsPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGPathSegArcAbsPrototypeTable = { 0, JSSVGPathSegArcAbsPrototypeTableValues, 0 };

const ClassInfo JSSVGPathSegArcAbsPrototype::s_info = { "SVGPathSegArcAbsPrototype", 0, &JSSVGPathSegArcAbsPrototypeTable, 0 };

JSObject* JSSVGPathSegArcAbsPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGPathSegArcAbs.prototype]]");
    return JSC::cacheGlobalObject<JSSVGPathSegArcAbsPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGPathSegArcAbs::s_info = { "SVGPathSegArcAbs", &JSSVGPathSeg::s_info, &JSSVGPathSegArcAbsTable , 0 };

JSSVGPathSegArcAbs::JSSVGPathSegArcAbs(JSObject* prototype, SVGPathSegArcAbs* impl, SVGElement* context)
    : JSSVGPathSeg(prototype, impl, context)
{
}

bool JSSVGPathSegArcAbs::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGPathSegArcAbs, Base>(exec, &JSSVGPathSegArcAbsTable, this, propertyName, slot);
}

JSValue* JSSVGPathSegArcAbs::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case XAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsNumber(exec, imp->x());
    }
    case YAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsNumber(exec, imp->y());
    }
    case R1AttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsNumber(exec, imp->r1());
    }
    case R2AttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsNumber(exec, imp->r2());
    }
    case AngleAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsNumber(exec, imp->angle());
    }
    case LargeArcFlagAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsBoolean(imp->largeArcFlag());
    }
    case SweepFlagAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        return jsBoolean(imp->sweepFlag());
    }
    }
    return 0;
}

void JSSVGPathSegArcAbs::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGPathSegArcAbs, Base>(exec, propertyName, value, &JSSVGPathSegArcAbsTable, this, slot);
}

void JSSVGPathSegArcAbs::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case XAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setX(value->toFloat(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    case YAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setY(value->toFloat(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    case R1AttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setR1(value->toFloat(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    case R2AttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setR2(value->toFloat(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    case AngleAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setAngle(value->toFloat(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    case LargeArcFlagAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setLargeArcFlag(value->toBoolean(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    case SweepFlagAttrNum: {
        SVGPathSegArcAbs* imp = static_cast<SVGPathSegArcAbs*>(impl());
        imp->setSweepFlag(value->toBoolean(exec));
        if (context())
            context()->svgAttributeChanged(impl()->associatedAttributeName());
        break;
    }
    }
}


}

#endif // ENABLE(SVG)
