/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGRadialGradientElement.h"

#include <wtf/GetPtr.h>

#include "JSSVGAnimatedLength.h"
#include "SVGRadialGradientElement.h"


using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGRadialGradientElement)

/* Hash table */

static const HashTableValue JSSVGRadialGradientElementTableValues[6] =
{
    { "cx", (intptr_t)JSSVGRadialGradientElement::CxAttrNum, DontDelete|ReadOnly, 0 },
    { "cy", (intptr_t)JSSVGRadialGradientElement::CyAttrNum, DontDelete|ReadOnly, 0 },
    { "r", (intptr_t)JSSVGRadialGradientElement::RAttrNum, DontDelete|ReadOnly, 0 },
    { "fx", (intptr_t)JSSVGRadialGradientElement::FxAttrNum, DontDelete|ReadOnly, 0 },
    { "fy", (intptr_t)JSSVGRadialGradientElement::FyAttrNum, DontDelete|ReadOnly, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGRadialGradientElementTable = { 255, JSSVGRadialGradientElementTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGRadialGradientElementPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGRadialGradientElementPrototypeTable = { 0, JSSVGRadialGradientElementPrototypeTableValues, 0 };

const ClassInfo JSSVGRadialGradientElementPrototype::s_info = { "SVGRadialGradientElementPrototype", 0, &JSSVGRadialGradientElementPrototypeTable, 0 };

JSObject* JSSVGRadialGradientElementPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGRadialGradientElement.prototype]]");
    return JSC::cacheGlobalObject<JSSVGRadialGradientElementPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGRadialGradientElement::s_info = { "SVGRadialGradientElement", &JSSVGGradientElement::s_info, &JSSVGRadialGradientElementTable , 0 };

JSSVGRadialGradientElement::JSSVGRadialGradientElement(JSObject* prototype, SVGRadialGradientElement* impl)
    : JSSVGGradientElement(prototype, impl)
{
}

bool JSSVGRadialGradientElement::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGRadialGradientElement, Base>(exec, &JSSVGRadialGradientElementTable, this, propertyName, slot);
}

JSValue* JSSVGRadialGradientElement::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case CxAttrNum: {
        SVGRadialGradientElement* imp = static_cast<SVGRadialGradientElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->cxAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case CyAttrNum: {
        SVGRadialGradientElement* imp = static_cast<SVGRadialGradientElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->cyAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case RAttrNum: {
        SVGRadialGradientElement* imp = static_cast<SVGRadialGradientElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->rAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case FxAttrNum: {
        SVGRadialGradientElement* imp = static_cast<SVGRadialGradientElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->fxAnimated();
        return toJS(exec, obj.get(), imp);
    }
    case FyAttrNum: {
        SVGRadialGradientElement* imp = static_cast<SVGRadialGradientElement*>(impl());
        RefPtr<SVGAnimatedLength> obj = imp->fyAnimated();
        return toJS(exec, obj.get(), imp);
    }
    }
    return 0;
}


}

#endif // ENABLE(SVG)
