/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGStyleElement.h"

#include <wtf/GetPtr.h>

#include "KURL.h"
#include "SVGStyleElement.h"

#include <kjs/JSString.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSSVGStyleElement)

/* Hash table */

static const HashTableValue JSSVGStyleElementTableValues[5] =
{
    { "xmlspace", (intptr_t)JSSVGStyleElement::XmlspaceAttrNum, DontDelete, 0 },
    { "type", (intptr_t)JSSVGStyleElement::TypeAttrNum, DontDelete, 0 },
    { "media", (intptr_t)JSSVGStyleElement::MediaAttrNum, DontDelete, 0 },
    { "title", (intptr_t)JSSVGStyleElement::TitleAttrNum, DontDelete, 0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGStyleElementTable = { 31, JSSVGStyleElementTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSSVGStyleElementPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSSVGStyleElementPrototypeTable = { 0, JSSVGStyleElementPrototypeTableValues, 0 };

const ClassInfo JSSVGStyleElementPrototype::s_info = { "SVGStyleElementPrototype", 0, &JSSVGStyleElementPrototypeTable, 0 };

JSObject* JSSVGStyleElementPrototype::self(ExecState* exec)
{
    static const Identifier* prototypeIdentifier = new Identifier(exec, "[[JSSVGStyleElement.prototype]]");
    return JSC::cacheGlobalObject<JSSVGStyleElementPrototype>(exec, *prototypeIdentifier);
}

const ClassInfo JSSVGStyleElement::s_info = { "SVGStyleElement", &JSSVGElement::s_info, &JSSVGStyleElementTable , 0 };

JSSVGStyleElement::JSSVGStyleElement(JSObject* prototype, SVGStyleElement* impl)
    : JSSVGElement(prototype, impl)
{
}

bool JSSVGStyleElement::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGStyleElement, Base>(exec, &JSSVGStyleElementTable, this, propertyName, slot);
}

JSValue* JSSVGStyleElement::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case XmlspaceAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        return jsString(exec, imp->xmlspace());
    }
    case TypeAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        return jsString(exec, imp->type());
    }
    case MediaAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        return jsString(exec, imp->media());
    }
    case TitleAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        return jsString(exec, imp->title());
    }
    }
    return 0;
}

void JSSVGStyleElement::put(ExecState* exec, const Identifier& propertyName, JSValue* value, PutPropertySlot& slot)
{
    lookupPut<JSSVGStyleElement, Base>(exec, propertyName, value, &JSSVGStyleElementTable, this, slot);
}

void JSSVGStyleElement::putValueProperty(ExecState* exec, int token, JSValue* value)
{
    switch (token) {
    case XmlspaceAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        ExceptionCode ec = 0;
        imp->setXmlspace(value->toString(exec), ec);
        setDOMException(exec, ec);
        break;
    }
    case TypeAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        ExceptionCode ec = 0;
        imp->setType(value->toString(exec), ec);
        setDOMException(exec, ec);
        break;
    }
    case MediaAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        ExceptionCode ec = 0;
        imp->setMedia(value->toString(exec), ec);
        setDOMException(exec, ec);
        break;
    }
    case TitleAttrNum: {
        SVGStyleElement* imp = static_cast<SVGStyleElement*>(impl());
        ExceptionCode ec = 0;
        imp->setTitle(value->toString(exec), ec);
        setDOMException(exec, ec);
        break;
    }
    }
}


}

#endif // ENABLE(SVG)
