/*
 * THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 *
 * Copyright (C) 2005 Apple Computer, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */


#include "config.h"
#include "SVGElementFactory.h"
#include "SVGNames.h"
#include "Page.h"
#include "Settings.h"
#include "SVGAElement.h"
#include "SVGAltGlyphElement.h"
#include "SVGAnimateElement.h"
#include "SVGAnimateColorElement.h"
#include "SVGAnimateMotionElement.h"
#include "SVGAnimateTransformElement.h"
#include "SVGCircleElement.h"
#include "SVGClipPathElement.h"
#include "SVGCursorElement.h"
#include "SVGDefinitionSrcElement.h"
#include "SVGDefsElement.h"
#include "SVGDescElement.h"
#include "SVGEllipseElement.h"
#include "SVGFontElement.h"
#include "SVGFontFaceElement.h"
#include "SVGFontFaceFormatElement.h"
#include "SVGFontFaceNameElement.h"
#include "SVGFontFaceSrcElement.h"
#include "SVGFontFaceUriElement.h"
#include "SVGForeignObjectElement.h"
#include "SVGGElement.h"
#include "SVGGlyphElement.h"
#include "SVGHKernElement.h"
#include "SVGImageElement.h"
#include "SVGLineElement.h"
#include "SVGLinearGradientElement.h"
#include "SVGMarkerElement.h"
#include "SVGMaskElement.h"
#include "SVGMetadataElement.h"
#include "SVGMissingGlyphElement.h"
#include "SVGMPathElement.h"
#include "SVGPathElement.h"
#include "SVGPatternElement.h"
#include "SVGPolygonElement.h"
#include "SVGPolylineElement.h"
#include "SVGRadialGradientElement.h"
#include "SVGRectElement.h"
#include "SVGScriptElement.h"
#include "SVGSetElement.h"
#include "SVGStopElement.h"
#include "SVGStyleElement.h"
#include "SVGSVGElement.h"
#include "SVGSwitchElement.h"
#include "SVGSymbolElement.h"
#include "SVGTextElement.h"
#include "SVGTextPathElement.h"
#include "SVGTitleElement.h"
#include "SVGTRefElement.h"
#include "SVGTSpanElement.h"
#include "SVGUseElement.h"
#include "SVGViewElement.h"
#include <wtf/HashMap.h>

using namespace WebCore;

typedef SVGElement* (*ConstructorFunc)(Document* doc, bool createdByParser);
typedef WTF::HashMap<AtomicStringImpl*, ConstructorFunc> FunctionMap;

static FunctionMap* gFunctionMap = 0;

namespace WebCore {

#if ENABLE(SVG)
SVGElement* aConstructor(Document* doc, bool createdByParser)
{
    return new SVGAElement(SVGNames::aTag, doc);
}

SVGElement* altGlyphConstructor(Document* doc, bool createdByParser)
{
    return new SVGAltGlyphElement(SVGNames::altGlyphTag, doc);
}

SVGElement* animateConstructor(Document* doc, bool createdByParser)
{
    return new SVGAnimateElement(SVGNames::animateTag, doc);
}

SVGElement* animateColorConstructor(Document* doc, bool createdByParser)
{
    return new SVGAnimateColorElement(SVGNames::animateColorTag, doc);
}

SVGElement* animateMotionConstructor(Document* doc, bool createdByParser)
{
    return new SVGAnimateMotionElement(SVGNames::animateMotionTag, doc);
}

SVGElement* animateTransformConstructor(Document* doc, bool createdByParser)
{
    return new SVGAnimateTransformElement(SVGNames::animateTransformTag, doc);
}

SVGElement* circleConstructor(Document* doc, bool createdByParser)
{
    return new SVGCircleElement(SVGNames::circleTag, doc);
}

SVGElement* clipPathConstructor(Document* doc, bool createdByParser)
{
    return new SVGClipPathElement(SVGNames::clipPathTag, doc);
}

SVGElement* cursorConstructor(Document* doc, bool createdByParser)
{
    return new SVGCursorElement(SVGNames::cursorTag, doc);
}

SVGElement* definition_srcConstructor(Document* doc, bool createdByParser)
{
    return new SVGDefinitionSrcElement(SVGNames::definition_srcTag, doc);
}

SVGElement* defsConstructor(Document* doc, bool createdByParser)
{
    return new SVGDefsElement(SVGNames::defsTag, doc);
}

SVGElement* descConstructor(Document* doc, bool createdByParser)
{
    return new SVGDescElement(SVGNames::descTag, doc);
}

SVGElement* ellipseConstructor(Document* doc, bool createdByParser)
{
    return new SVGEllipseElement(SVGNames::ellipseTag, doc);
}

SVGElement* fontConstructor(Document* doc, bool createdByParser)
{
    return new SVGFontElement(SVGNames::fontTag, doc);
}

SVGElement* font_faceConstructor(Document* doc, bool createdByParser)
{
    return new SVGFontFaceElement(SVGNames::font_faceTag, doc);
}

SVGElement* font_face_formatConstructor(Document* doc, bool createdByParser)
{
    return new SVGFontFaceFormatElement(SVGNames::font_face_formatTag, doc);
}

SVGElement* font_face_nameConstructor(Document* doc, bool createdByParser)
{
    return new SVGFontFaceNameElement(SVGNames::font_face_nameTag, doc);
}

SVGElement* font_face_srcConstructor(Document* doc, bool createdByParser)
{
    return new SVGFontFaceSrcElement(SVGNames::font_face_srcTag, doc);
}

SVGElement* font_face_uriConstructor(Document* doc, bool createdByParser)
{
    return new SVGFontFaceUriElement(SVGNames::font_face_uriTag, doc);
}

SVGElement* foreignObjectConstructor(Document* doc, bool createdByParser)
{
    return new SVGForeignObjectElement(SVGNames::foreignObjectTag, doc);
}

SVGElement* gConstructor(Document* doc, bool createdByParser)
{
    return new SVGGElement(SVGNames::gTag, doc);
}

SVGElement* glyphConstructor(Document* doc, bool createdByParser)
{
    return new SVGGlyphElement(SVGNames::glyphTag, doc);
}

SVGElement* hkernConstructor(Document* doc, bool createdByParser)
{
    return new SVGHKernElement(SVGNames::hkernTag, doc);
}

SVGElement* imageConstructor(Document* doc, bool createdByParser)
{
    return new SVGImageElement(SVGNames::imageTag, doc);
}

SVGElement* lineConstructor(Document* doc, bool createdByParser)
{
    return new SVGLineElement(SVGNames::lineTag, doc);
}

SVGElement* linearGradientConstructor(Document* doc, bool createdByParser)
{
    return new SVGLinearGradientElement(SVGNames::linearGradientTag, doc);
}

SVGElement* markerConstructor(Document* doc, bool createdByParser)
{
    return new SVGMarkerElement(SVGNames::markerTag, doc);
}

SVGElement* maskConstructor(Document* doc, bool createdByParser)
{
    return new SVGMaskElement(SVGNames::maskTag, doc);
}

SVGElement* metadataConstructor(Document* doc, bool createdByParser)
{
    return new SVGMetadataElement(SVGNames::metadataTag, doc);
}

SVGElement* missing_glyphConstructor(Document* doc, bool createdByParser)
{
    return new SVGMissingGlyphElement(SVGNames::missing_glyphTag, doc);
}

SVGElement* mpathConstructor(Document* doc, bool createdByParser)
{
    return new SVGMPathElement(SVGNames::mpathTag, doc);
}

SVGElement* pathConstructor(Document* doc, bool createdByParser)
{
    return new SVGPathElement(SVGNames::pathTag, doc);
}

SVGElement* patternConstructor(Document* doc, bool createdByParser)
{
    return new SVGPatternElement(SVGNames::patternTag, doc);
}

SVGElement* polygonConstructor(Document* doc, bool createdByParser)
{
    return new SVGPolygonElement(SVGNames::polygonTag, doc);
}

SVGElement* polylineConstructor(Document* doc, bool createdByParser)
{
    return new SVGPolylineElement(SVGNames::polylineTag, doc);
}

SVGElement* radialGradientConstructor(Document* doc, bool createdByParser)
{
    return new SVGRadialGradientElement(SVGNames::radialGradientTag, doc);
}

SVGElement* rectConstructor(Document* doc, bool createdByParser)
{
    return new SVGRectElement(SVGNames::rectTag, doc);
}

SVGElement* scriptConstructor(Document* doc, bool createdByParser)
{
    return new SVGScriptElement(SVGNames::scriptTag, doc);
}

SVGElement* setConstructor(Document* doc, bool createdByParser)
{
    return new SVGSetElement(SVGNames::setTag, doc);
}

SVGElement* stopConstructor(Document* doc, bool createdByParser)
{
    return new SVGStopElement(SVGNames::stopTag, doc);
}

SVGElement* styleConstructor(Document* doc, bool createdByParser)
{
    return new SVGStyleElement(SVGNames::styleTag, doc);
}

SVGElement* svgConstructor(Document* doc, bool createdByParser)
{
    return new SVGSVGElement(SVGNames::svgTag, doc);
}

SVGElement* switchConstructor(Document* doc, bool createdByParser)
{
    return new SVGSwitchElement(SVGNames::switchTag, doc);
}

SVGElement* symbolConstructor(Document* doc, bool createdByParser)
{
    return new SVGSymbolElement(SVGNames::symbolTag, doc);
}

SVGElement* textConstructor(Document* doc, bool createdByParser)
{
    return new SVGTextElement(SVGNames::textTag, doc);
}

SVGElement* textPathConstructor(Document* doc, bool createdByParser)
{
    return new SVGTextPathElement(SVGNames::textPathTag, doc);
}

SVGElement* titleConstructor(Document* doc, bool createdByParser)
{
    return new SVGTitleElement(SVGNames::titleTag, doc);
}

SVGElement* trefConstructor(Document* doc, bool createdByParser)
{
    return new SVGTRefElement(SVGNames::trefTag, doc);
}

SVGElement* tspanConstructor(Document* doc, bool createdByParser)
{
    return new SVGTSpanElement(SVGNames::tspanTag, doc);
}

SVGElement* useConstructor(Document* doc, bool createdByParser)
{
    return new SVGUseElement(SVGNames::useTag, doc);
}

SVGElement* viewConstructor(Document* doc, bool createdByParser)
{
    return new SVGViewElement(SVGNames::viewTag, doc);
}

#endif
#if ENABLE(SVG)
static inline void createFunctionMapIfNecessary()
{
    if (gFunctionMap)
        return;
    // Create the table.
    gFunctionMap = new FunctionMap;
    
    // Populate it with constructor functions.
    gFunctionMap->set(SVGNames::aTag.localName().impl(), aConstructor);
    gFunctionMap->set(SVGNames::altGlyphTag.localName().impl(), altGlyphConstructor);
    gFunctionMap->set(SVGNames::animateTag.localName().impl(), animateConstructor);
    gFunctionMap->set(SVGNames::animateColorTag.localName().impl(), animateColorConstructor);
    gFunctionMap->set(SVGNames::animateMotionTag.localName().impl(), animateMotionConstructor);
    gFunctionMap->set(SVGNames::animateTransformTag.localName().impl(), animateTransformConstructor);
    gFunctionMap->set(SVGNames::circleTag.localName().impl(), circleConstructor);
    gFunctionMap->set(SVGNames::clipPathTag.localName().impl(), clipPathConstructor);
    gFunctionMap->set(SVGNames::cursorTag.localName().impl(), cursorConstructor);
    gFunctionMap->set(SVGNames::definition_srcTag.localName().impl(), definition_srcConstructor);
    gFunctionMap->set(SVGNames::defsTag.localName().impl(), defsConstructor);
    gFunctionMap->set(SVGNames::descTag.localName().impl(), descConstructor);
    gFunctionMap->set(SVGNames::ellipseTag.localName().impl(), ellipseConstructor);
    gFunctionMap->set(SVGNames::fontTag.localName().impl(), fontConstructor);
    gFunctionMap->set(SVGNames::font_faceTag.localName().impl(), font_faceConstructor);
    gFunctionMap->set(SVGNames::font_face_formatTag.localName().impl(), font_face_formatConstructor);
    gFunctionMap->set(SVGNames::font_face_nameTag.localName().impl(), font_face_nameConstructor);
    gFunctionMap->set(SVGNames::font_face_srcTag.localName().impl(), font_face_srcConstructor);
    gFunctionMap->set(SVGNames::font_face_uriTag.localName().impl(), font_face_uriConstructor);
    gFunctionMap->set(SVGNames::foreignObjectTag.localName().impl(), foreignObjectConstructor);
    gFunctionMap->set(SVGNames::gTag.localName().impl(), gConstructor);
    gFunctionMap->set(SVGNames::glyphTag.localName().impl(), glyphConstructor);
    gFunctionMap->set(SVGNames::hkernTag.localName().impl(), hkernConstructor);
    gFunctionMap->set(SVGNames::imageTag.localName().impl(), imageConstructor);
    gFunctionMap->set(SVGNames::lineTag.localName().impl(), lineConstructor);
    gFunctionMap->set(SVGNames::linearGradientTag.localName().impl(), linearGradientConstructor);
    gFunctionMap->set(SVGNames::markerTag.localName().impl(), markerConstructor);
    gFunctionMap->set(SVGNames::maskTag.localName().impl(), maskConstructor);
    gFunctionMap->set(SVGNames::metadataTag.localName().impl(), metadataConstructor);
    gFunctionMap->set(SVGNames::missing_glyphTag.localName().impl(), missing_glyphConstructor);
    gFunctionMap->set(SVGNames::mpathTag.localName().impl(), mpathConstructor);
    gFunctionMap->set(SVGNames::pathTag.localName().impl(), pathConstructor);
    gFunctionMap->set(SVGNames::patternTag.localName().impl(), patternConstructor);
    gFunctionMap->set(SVGNames::polygonTag.localName().impl(), polygonConstructor);
    gFunctionMap->set(SVGNames::polylineTag.localName().impl(), polylineConstructor);
    gFunctionMap->set(SVGNames::radialGradientTag.localName().impl(), radialGradientConstructor);
    gFunctionMap->set(SVGNames::rectTag.localName().impl(), rectConstructor);
    gFunctionMap->set(SVGNames::scriptTag.localName().impl(), scriptConstructor);
    gFunctionMap->set(SVGNames::setTag.localName().impl(), setConstructor);
    gFunctionMap->set(SVGNames::stopTag.localName().impl(), stopConstructor);
    gFunctionMap->set(SVGNames::styleTag.localName().impl(), styleConstructor);
    gFunctionMap->set(SVGNames::svgTag.localName().impl(), svgConstructor);
    gFunctionMap->set(SVGNames::switchTag.localName().impl(), switchConstructor);
    gFunctionMap->set(SVGNames::symbolTag.localName().impl(), symbolConstructor);
    gFunctionMap->set(SVGNames::textTag.localName().impl(), textConstructor);
    gFunctionMap->set(SVGNames::textPathTag.localName().impl(), textPathConstructor);
    gFunctionMap->set(SVGNames::titleTag.localName().impl(), titleConstructor);
    gFunctionMap->set(SVGNames::trefTag.localName().impl(), trefConstructor);
    gFunctionMap->set(SVGNames::tspanTag.localName().impl(), tspanConstructor);
    gFunctionMap->set(SVGNames::useTag.localName().impl(), useConstructor);
    gFunctionMap->set(SVGNames::viewTag.localName().impl(), viewConstructor);
}
#endif

SVGElement* SVGElementFactory::createSVGElement(const QualifiedName& qName, Document* doc, bool createdByParser)
{
#if ENABLE(SVG)
    // Don't make elements without a document
    if (!doc)
        return 0;

#if ENABLE(DASHBOARD_SUPPORT)
    Settings* settings = doc->settings();
    if (settings && settings->usesDashboardBackwardCompatibilityMode())
        return 0;
#endif

    createFunctionMapIfNecessary();
    ConstructorFunc func = gFunctionMap->get(qName.localName().impl());
    if (func)
        return func(doc, createdByParser);

    return new SVGElement(qName, doc);
#else
    return 0;
#endif
}

} // namespace

